Index: WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/XUSNPI.m
===================================================================
--- WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/XUSNPI.m	(revision 613)
+++ WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/XUSNPI.m	(revision 623)
@@ -1,201 +1,189 @@
-XUSNPI	;OAK_BP/BDT - NATIONAL PROVIDER IDENTIFIER ;6/3/08  13:51
-	;;8.0;KERNEL;**410,416,480**; July 10, 1995;Build 38
-	;;Per VHA Directive 2004-038, this routine should not be modified
-ADDNPI(XUSQI,XUSIEN,XUSNPI,XUSDATE,XUSTATUS)	;
-	;;==============================================================
-	;; Update the Effective Date, Status & NPI trio.
-	;; XUSQI   : Qualified Identifier, Required. For examble: Individual_ID Or Organization_ID
-	;; XUSIEN  : Internal Entry Number. Required.
-	;; XUSNPI  : National Provider Identifier. Required.
-	;; XUSDATE : Active Date. Required.
-	;; 
-	;; If successful, return XUSRTN = IEN of new 42 sub-file entry.
-	;; Else return XUSRTN = "-1^ErrorMessage".
-	;; =============================================================
-	;
-	; Check valid inputs.
-	N XUSROOT,XUSFNB
-	S XUSROOT=$$GET^XPAR("PKG.KERNEL","XUSNPI QUALIFIED IDENTIFIER",XUSQI)
-	I $E(XUSROOT)'="^" S XUSROOT="^"_XUSROOT
-	I XUSROOT="^" Q "-1^Invalid Qualified Identifier"
-	I $$GLCK(XUSROOT)'>0 Q "-1^Invalid Qualified Identifier"
-	S XUSFNB=+$P(XUSROOT,"(",2)
-	I 'XUSFNB Q "-1^No File #"
-	S XUSFNB=XUSFNB_".42"
-	I $G(XUSIEN)'>0 Q "-1^Invalid IEN"
-	;I (XUSIEN?.N)=0 Q "-1^Invalid IEN"
-	I ((XUSIEN?.N)!(XUSIEN?.N1"."1N.N))=0 Q "-1^Invalid IEN"
-	N XUIENCK S XUIENCK=XUSROOT_XUSIEN_","_0_")" I '$D(@XUIENCK) Q "-1^Invalid IEN"
-	I '$$CHKDGT(XUSNPI) Q "-1^Invalid NPI"
-	I '$$CHKDT(XUSQI,XUSIEN,XUSDATE) Q "-1^Invalid Effective Date"
-	I $G(XUSTATUS)="" S XUSTATUS=1
-	I (XUSTATUS'=0),(XUSTATUS'=1) Q "-1^Invalid Status"
-	N CHNPI S CHNPI=$$CHKDGT^XUSNPIE1(XUSNPI,XUSIEN,XUSQI) ; check if NPI is being used.
-	I CHNPI'=1 Q "-1^The NPI is being used."
-	;
-	;------------------------------------------------------------------
-	N ZZ,XUSRTN,ERRMSG,XUSX S ERRMSG=""
-	S XUSX=XUSROOT_XUSIEN_","_"""NPISTATUS"""_")"
-	; Update Effective Date #42 multiple fields 
-	S XUSFNB=$P(XUSROOT,"(",2)
-	S XUSFNB=+$P(XUSFNB,",") I XUSFNB S XUSFNB=XUSFNB_".042"
-	S ZZ(1,XUSFNB,"+2,"_XUSIEN_",",.01)=XUSDATE
-	S ZZ(1,XUSFNB,"+2,"_XUSIEN_",",.02)=XUSTATUS
-	S ZZ(1,XUSFNB,"+2,"_XUSIEN_",",.03)=XUSNPI
-	D UPDATE^DIE("","ZZ(1)",,ERRMSG)
-	I $L(ERRMSG) Q "-1^"_$G(ERRMSG)
-	S XUSX=XUSROOT_XUSIEN_","_"""NPISTATUS"""_","_"""B"""_","_XUSDATE_","_"""A"""_")"
-	S XUSRTN=$O(@XUSX,-1)
-	I '+XUSRTN Q "-1^No entry add"
-	Q XUSRTN
-	;
-NPI(XUSQI,XUSIEN,XUSDATE)	; Retrieve the NPI value for a qualified identifier entity.
-	;;==============================================================
-	;; XUSQI   : Qualified Identifier, Required. For examble: Individual_ID Or Organization_ID
-	;; XUSIEN  : Internal Entry Number of file #4 or #200. Required.
-	;; XUSDATE : Active Date. Not Required. Default: 'Today'.
-	;; 
-	;; If current NPI exists, return XUSRTN = 'NPI^EffectiveDate^Status'
-	;; If invalid XUSQI or XUSIEN, return '-1^ErrorMessage'
-	;; Else return 0
-	;; =============================================================
-	; check valid inputs
-	I $G(XUSIEN)'>0 Q "-1^Invalid IEN"
-	;I (XUSIEN?.N)=0 Q "-1^Invalid IEN"
-	I ((XUSIEN?.N)!(XUSIEN?.N1"."1N.N))=0 Q "-1^Invalid IEN"
-	I $G(XUSDATE)="" S XUSDATE=$$NOW^XLFDT
-	N X,Y,%DT S %DT="T",X=XUSDATE D ^%DT I Y'=XUSDATE Q "-1^Invalid Effective Date"
-	;-----------------------------------
-	N XUSDA,XUSI,XUSRTN,XUSROOT,XUSX,XUSTAT S (XUSDA,XUSRTN)="",XUSTAT="Inactive"
-	; get global from Parameter file base on Qualified Identifier.
-	S XUSROOT=$$GET^XPAR("PKG.KERNEL","XUSNPI QUALIFIED IDENTIFIER",XUSQI)
-	I $E(XUSROOT)'="^" S XUSROOT="^"_XUSROOT
-	I XUSROOT="^" Q "-1^Invalid Qualified Identifier"
-	N XUIENCK S XUIENCK=XUSROOT_XUSIEN_","_0_")" I '$D(@XUIENCK) Q "-1^Invalid IEN"
-	I $$GLCK(XUSROOT)'>0 Q "-1^Invalid Qualified Identifier"
-	S XUSROOT=XUSROOT_XUSIEN_","_"""NPISTATUS"""
-	S XUSX=XUSROOT_")" I '$D(@XUSX) Q "-1^No NPI found"
-	S XUSI=0 F  S XUSI=$O(@(XUSROOT_","_"""B"""_","_XUSI_")")) Q:XUSI>XUSDATE!'XUSI
-	I 'XUSI S XUSX=XUSROOT_","_"""B"""_","_"""A"""_")",XUSDA=$O(@XUSX,-1)
-	I XUSI>XUSDATE S XUSX=XUSROOT_","_"""B"""_","_XUSI_")",XUSDA=$O(@(XUSX),-1)
-	I XUSDA="" Q 0
-	S XUSDA=XUSROOT_","_"""B"""_","_XUSDA_","_"""A"""_")",XUSDA=$O(@XUSDA,-1)
-	S XUSRTN=XUSROOT_","_XUSDA_","_0_")"
-	I '$D(@XUSRTN) Q "-1^Invalid IEN"
-	I $P($G(@XUSRTN),"^",2)=1 S XUSTAT="Active"
-	Q $P($G(@XUSRTN),"^",3)_"^"_$P($G(@XUSRTN),"^",1)_"^"_XUSTAT
-	;       
-QI(XUSNPI)	; Retrieve the ALL qualified indentifier entity for an NPI value.
-	;;================================================
-	;; XUSNPI  : National Provider Identifier. Required
-	;; 
-	;; If qualified identified entity exists, return
-	;; 'QualifiedIdentifier^IEN^EffectiveDate^Status;'
-	;; If more than one records found, they are separated by ";"
-	;; Else return 0        
-	;;================================================
-	; check valid NPI
-	I '$$CHKDGT(XUSNPI) Q "0^Invalid NPI"
-	N ZZ
-	D GETLST^XPAR(.ZZ,"PKG.KERNEL","XUSNPI QUALIFIED IDENTIFIER")
-	I ZZ'>0 Q 0
-	N XUSI,XUSIEN,XUSROOT,XUSQT,XUSX,XUSRTN,XUSRTN1 S (XUSQT,XUSRTN)=0,XUSRTN1=""
-	S XUSI=0 F  S XUSI=$O(ZZ(XUSI)) Q:'XUSI  D
-	. S XUSROOT=$P(ZZ(XUSI),"^",2),XUSROOT="^"_XUSROOT
-	. I $$GLCK(XUSROOT)'>0 Q  ;check valid global root
-	. I $E(XUSNPI,1,1)=0 S XUSNPI=""""_XUSNPI_""""
-	. S XUSX=XUSROOT_"""NPI42"""_","_XUSNPI_")" Q:'$D(@XUSX)
-	. S XUSIEN=0 F  S XUSX=XUSROOT_"""NPI42"""_","_XUSNPI_","_XUSIEN_")",XUSIEN=$O(@XUSX) Q:XUSIEN'>0  D
-	. . S XUSRTN=$$SRCHNPI(XUSROOT,XUSIEN,XUSNPI)
-	. . I +XUSRTN S XUSRTN1=XUSRTN1_$P(ZZ(XUSI),"^")_"^"_XUSRTN_";",XUSQT=XUSQT+1
-	I XUSRTN1="" S XUSRTN1=0
-	Q XUSRTN1
-	;
-GLCK(XUSROOT)	; check valid global root
-	N XUFNB,ZZ
-	I $G(XUSROOT)="" Q 0
-	S XUFNB=$P(XUSROOT,"(",2),XUFNB=$P(XUFNB,",")
-	D FILE^DID(XUFNB,"","GLOBAL NAME","ZZ")
-	Q (XUSROOT=$G(ZZ("GLOBAL NAME")))
-	;
-SRCHNPI(XUSROOT,XUSIEN,XUSNPI)	;
-	I $G(XUSIEN)'>0 Q 0
-	I (XUSIEN?.N)=0 Q 0
-	N XUSX,XUSRTN S XUSRTN=0
-	I $E(XUSNPI,1,1)=0 S XUSNPI=""""_XUSNPI_""""
-	S XUSX=XUSROOT_XUSIEN_","_"""NPISTATUS"""_","_"""C"""_","_XUSNPI_")"
-	I '$D(@XUSX) Q 0
-	S XUSX=XUSROOT_XUSIEN_","_"""NPISTATUS"""_","_"""C"""_","_XUSNPI_","_"""A"""_")"
-	S XUSRTN=$O(@XUSX,-1)
-	I '+XUSRTN Q 0
-	S XUSX=XUSROOT_XUSIEN_","_"""NPISTATUS"""_","_XUSRTN_","_0_")"
-	I '$D(@XUSX) Q 0
-	S XUSRTN=$G(@XUSX) I XUSRTN S XUSRTN=XUSIEN_"^"_$P(XUSRTN,"^")_"^"_$P(XUSRTN,"^",2)
-	I $P(XUSRTN,"^",3)=1 S $P(XUSRTN,"^",3)="Active"
-	I $P(XUSRTN,"^",3)=0 S $P(XUSRTN,"^",3)="Inactive"
-	Q XUSRTN
-	;
-CHKDGT(XUSNPI)	;
-	;  Function to validate the format of an NPI number.  It checks the
-	;  length of the number, whether the NPI is numeric, and whether
-	;  the check digit is valid.
-	;
-	;  Input parameter:
-	;    NPI - 10-digit NPI number to validate.
-	;
-	;  Output parameter:
-	;    Boolean value indicating whether the NPI has a valid format
-	;
-	;  NPI must be 10 digits long.
-	I XUSNPI'?10N Q 0
-	Q $E(XUSNPI,10)=$$CKDIGIT($E(XUSNPI,1,9))
-	;
-CKDIGIT(XUSNPI)	;
-	;  Function to calculate and return the check digit of an NPI.
-	;  The check digit is calculated using the Luhn Formula for
-	;  Modulus 10 "double-add-double" Check Digit.  A value of 24 is
-	;  added to the total to account for the implied USA (80840) prefix.
-	;
-	N XUSCTOT,XUSCN,XUSCDIG,XUSI
-	S XUSCTOT=24
-	F XUSI=9:-2:1 S XUSCN=2*$E(XUSNPI,XUSI),XUSCTOT=XUSCTOT+$E(XUSCN)+$E(XUSCN,2)+$E(XUSNPI,XUSI-1)
-	S XUSCDIG=150-XUSCTOT
-	Q $E(XUSCDIG,$L(XUSCDIG))
-	;
-CHKDT(XUSQI,XUSIEN,XUSDATE)	; Check Date
-	;;============================================================================
-	;;  XUSQI   : Qualified Identifier. Required. For examble: "Individual_ID"
-	;;  XUSIEN  : Internal Entry Number. Required.
-	;;  XUSDATE : The Effective Date value to test. Must be FM date. Required. 
-	;;  
-	;;  If input passes date comparison, return 1.
-	;;  Else return 0.
-	;;============================================================================
-	; 
-	I $G(XUSIEN)'>0 Q "0^Invalid IEN."
-	;I (XUSIEN?.N)=0 Q "0^Invalid IEN."
-	I ((XUSIEN?.N)!(XUSIEN?.N1"."1N.N))=0 Q "-1^Invalid IEN"
-	N X,Y,%DT S %DT="T",X=$G(XUSDATE) D ^%DT I Y'=XUSDATE Q "0^Invalid Effective Date. Must be FM Date/Time."
-	;-----------------------------------
-	N XUSROOT,XUSDA
-	N XUSCRDT S XUSCRDT=$$NOW^XLFDT I XUSDATE>XUSCRDT Q 0
-	; get global from Parameter file base on Qualified Identifier.
-	S XUSROOT=$$GET^XPAR("PKG.KERNEL","XUSNPI QUALIFIED IDENTIFIER",XUSQI)
-	I $E(XUSROOT)'="^" S XUSROOT="^"_XUSROOT
-	I XUSROOT="^" Q "0^Invalid Qualified Identifier."
-	I $$GLCK(XUSROOT)'>0 Q "-1^Invalid Qualified Identifier"
-	N XUIENCK S XUIENCK=XUSROOT_XUSIEN_","_0_")" I $D(@XUIENCK)'>0 Q "0^Invalid IEN."
-	S XUSROOT=XUSROOT_XUSIEN_","_"""NPISTATUS"""_","_"""B"""_","_"""A"""_")",XUSDA=$O(@XUSROOT,-1)
-	Q (XUSDATE'<XUSDA)
-	;
-GETRLNPI(XUSIEN)	; Return field indicating blanket release of NPI
-	;; XUSIEN  : Internal Entry Number of person in file 200. Required
-	;; Output: -1^error message or contents of AUTHORIZE RELEASE OF NPI field.
-	S XUSIEN=+$G(XUSIEN) I $G(^VA(200,XUSIEN,0))="" Q "-1^Invalid IEN"
-	N X
-	S X=$$NPI^XUSNPI("Individual_ID",XUSIEN)
-	I (X'>0)!($P(X,U,3)'="Active") Q "-1^User has no active NPI"
-	S X=$P($G(^VA(200,XUSIEN,"NPI")),U,3)
-	S:X="" X=0
-	Q X
-	;
+XUSNPI ;OAK_BP/BDT - NATIONAL PROVIDER IDENTIFIER; 8/10/06
+ ;;8.0;KERNEL;**410,416**; July 10, 1997;Build 5
+ ;;
+ADDNPI(XUSQI,XUSIEN,XUSNPI,XUSDATE,XUSTATUS) ;
+ ;;==============================================================
+ ;; Update the Effective Date, Status & NPI trio.
+ ;; XUSQI   : Qualified Identifier, Required. For examble: Individual_ID Or Organization_ID
+ ;; XUSIEN  : Internal Entry Number. Required.
+ ;; XUSNPI  : National Provider Identifier. Required.
+ ;; XUSDATE : Active Date. Required.
+ ;; 
+ ;; If successful, return XUSRTN = IEN of new 42 sub-file entry.
+ ;; Else return XUSRTN = "-1^ErrorMessage".
+ ;; =============================================================
+ ;
+ ; Check valid inputs.
+ N XUSROOT,XUSFNB
+ S XUSROOT=$$GET^XPAR("PKG.KERNEL","XUSNPI QUALIFIED IDENTIFIER",XUSQI)
+ I $E(XUSROOT)'="^" S XUSROOT="^"_XUSROOT
+ I XUSROOT="^" Q "-1^Invalid Qualified Identifier"
+ I $$GLCK(XUSROOT)'>0 Q "-1^Invalid Qualified Identifier"
+ S XUSFNB=+$P(XUSROOT,"(",2)
+ I 'XUSFNB Q "-1^No File #"
+ S XUSFNB=XUSFNB_".42"
+ I $G(XUSIEN)'>0 Q "-1^Invalid IEN"
+ ;I (XUSIEN?.N)=0 Q "-1^Invalid IEN"
+ I ((XUSIEN?.N)!(XUSIEN?.N1"."1N.N))=0 Q "-1^Invalid IEN"
+ N XUIENCK S XUIENCK=XUSROOT_XUSIEN_","_0_")" I '$D(@XUIENCK) Q "-1^Invalid IEN"
+ I '$$CHKDGT(XUSNPI) Q "-1^Invalid NPI"
+ I '$$CHKDT(XUSQI,XUSIEN,XUSDATE) Q "-1^Invalid Effective Date"
+ I $G(XUSTATUS)="" S XUSTATUS=1
+ I (XUSTATUS'=0),(XUSTATUS'=1) Q "-1^Invalid Status"
+ N CHNPI S CHNPI=$$CHKDGT^XUSNPIE1(XUSNPI,XUSIEN,XUSQI) ; check if NPI is being used.
+ I CHNPI'=1 Q "-1^The NPI is being used."
+ ;
+ ;------------------------------------------------------------------
+ N ZZ,XUSRTN,ERRMSG,XUSX S ERRMSG=""
+ S XUSX=XUSROOT_XUSIEN_","_"""NPISTATUS"""_")"
+ ; Update Effective Date #42 multiple fields 
+ S XUSFNB=$P(XUSROOT,"(",2)
+ S XUSFNB=+$P(XUSFNB,",") I XUSFNB S XUSFNB=XUSFNB_".042"
+ S ZZ(1,XUSFNB,"+2,"_XUSIEN_",",.01)=XUSDATE
+ S ZZ(1,XUSFNB,"+2,"_XUSIEN_",",.02)=XUSTATUS
+ S ZZ(1,XUSFNB,"+2,"_XUSIEN_",",.03)=XUSNPI
+ D UPDATE^DIE("","ZZ(1)",,ERRMSG)
+ I $L(ERRMSG) Q "-1^"_$G(ERRMSG)
+ S XUSX=XUSROOT_XUSIEN_","_"""NPISTATUS"""_","_"""B"""_","_XUSDATE_","_"""A"""_")"
+ S XUSRTN=$O(@XUSX,-1)
+ I '+XUSRTN Q "-1^No entry add"
+ Q XUSRTN
+ ;
+NPI(XUSQI,XUSIEN,XUSDATE) ; Retrieve the NPI value for a qualified identifier entity.
+ ;;==============================================================
+ ;; XUSQI   : Qualified Identifier, Required. For examble: Individual_ID Or Organization_ID
+ ;; XUSIEN  : Internal Entry Number of file #4 or #200. Required.
+ ;; XUSDATE : Active Date. Not Required. Default: 'Today'.
+ ;; 
+ ;; If current NPI exists, return XUSRTN = 'NPI^EffectiveDate^Status'
+ ;; If invalid XUSQI or XUSIEN, return '-1^ErrorMessage'
+ ;; Else return 0
+ ;; =============================================================
+ ; check valid inputs
+ I $G(XUSIEN)'>0 Q "-1^Invalid IEN"
+ ;I (XUSIEN?.N)=0 Q "-1^Invalid IEN"
+ I ((XUSIEN?.N)!(XUSIEN?.N1"."1N.N))=0 Q "-1^Invalid IEN"
+ I $G(XUSDATE)="" S XUSDATE=$$NOW^XLFDT
+ N X,Y,%DT S %DT="T",X=XUSDATE D ^%DT I Y'=XUSDATE Q "-1^Invalid Effective Date"
+ ;-----------------------------------
+ N XUSDA,XUSI,XUSRTN,XUSROOT,XUSX,XUSTAT S (XUSDA,XUSRTN)="",XUSTAT="Inactive"
+ ; get global from Parameter file base on Qualified Identifier.
+ S XUSROOT=$$GET^XPAR("PKG.KERNEL","XUSNPI QUALIFIED IDENTIFIER",XUSQI)
+ I $E(XUSROOT)'="^" S XUSROOT="^"_XUSROOT
+ I XUSROOT="^" Q "-1^Invalid Qualified Identifier"
+ N XUIENCK S XUIENCK=XUSROOT_XUSIEN_","_0_")" I '$D(@XUIENCK) Q "-1^Invalid IEN"
+ I $$GLCK(XUSROOT)'>0 Q "-1^Invalid Qualified Identifier"
+ S XUSROOT=XUSROOT_XUSIEN_","_"""NPISTATUS"""
+ S XUSX=XUSROOT_")" I '$D(@XUSX) Q "-1^No NPI found"
+ S XUSI=0 F  S XUSI=$O(@(XUSROOT_","_"""B"""_","_XUSI_")")) Q:XUSI>XUSDATE!'XUSI
+ I 'XUSI S XUSX=XUSROOT_","_"""B"""_","_"""A"""_")",XUSDA=$O(@XUSX,-1)
+ I XUSI>XUSDATE S XUSX=XUSROOT_","_"""B"""_","_XUSI_")",XUSDA=$O(@(XUSX),-1)
+ I XUSDA="" Q 0
+ S XUSDA=XUSROOT_","_"""B"""_","_XUSDA_","_"""A"""_")",XUSDA=$O(@XUSDA,-1)
+ S XUSRTN=XUSROOT_","_XUSDA_","_0_")"
+ I '$D(@XUSRTN) Q "-1^Invalid IEN"
+ I $P($G(@XUSRTN),"^",2)=1 S XUSTAT="Active"
+ Q $P($G(@XUSRTN),"^",3)_"^"_$P($G(@XUSRTN),"^",1)_"^"_XUSTAT
+ ;       
+QI(XUSNPI) ; Retrieve the ALL qualified indentifier entity for an NPI value.
+ ;;================================================
+ ;; XUSNPI  : National Provider Identifier. Required
+ ;; 
+ ;; If qualified identified entity exists, return
+ ;; 'QualifiedIdentifier^IEN^EffectiveDate^Status;'
+ ;; If more than one records found, they are separated by ";"
+ ;; Else return 0        
+ ;;================================================
+ ; check valid NPI
+ I '$$CHKDGT(XUSNPI) Q "0^Invalid NPI"
+ N ZZ
+ D GETLST^XPAR(.ZZ,"PKG.KERNEL","XUSNPI QUALIFIED IDENTIFIER")
+ I ZZ'>0 Q 0
+ N XUSI,XUSIEN,XUSROOT,XUSQT,XUSX,XUSRTN,XUSRTN1 S (XUSQT,XUSRTN)=0,XUSRTN1=""
+ S XUSI=0 F  S XUSI=$O(ZZ(XUSI)) Q:'XUSI  D
+ . S XUSROOT=$P(ZZ(XUSI),"^",2),XUSROOT="^"_XUSROOT
+ . I $$GLCK(XUSROOT)'>0 Q  ;check valid global root
+ . I $E(XUSNPI,1,1)=0 S XUSNPI=""""_XUSNPI_""""
+ . S XUSX=XUSROOT_"""NPI42"""_","_XUSNPI_")" Q:'$D(@XUSX)
+ . S XUSIEN=0 F  S XUSX=XUSROOT_"""NPI42"""_","_XUSNPI_","_XUSIEN_")",XUSIEN=$O(@XUSX) Q:XUSIEN'>0  D
+ . . S XUSRTN=$$SRCHNPI(XUSROOT,XUSIEN,XUSNPI)
+ . . I +XUSRTN S XUSRTN1=XUSRTN1_$P(ZZ(XUSI),"^")_"^"_XUSRTN_";",XUSQT=XUSQT+1
+ I XUSRTN1="" S XUSRTN1=0
+ Q XUSRTN1
+ ;
+GLCK(XUSROOT) ; check valid global root
+ N XUFNB,ZZ
+ I $G(XUSROOT)="" Q 0
+ S XUFNB=$P(XUSROOT,"(",2),XUFNB=$P(XUFNB,",")
+ D FILE^DID(XUFNB,"","GLOBAL NAME","ZZ")
+ Q (XUSROOT=$G(ZZ("GLOBAL NAME")))
+ ;
+SRCHNPI(XUSROOT,XUSIEN,XUSNPI) ;
+ I $G(XUSIEN)'>0 Q 0
+ I (XUSIEN?.N)=0 Q 0
+ N XUSX,XUSRTN S XUSRTN=0
+ I $E(XUSNPI,1,1)=0 S XUSNPI=""""_XUSNPI_""""
+ S XUSX=XUSROOT_XUSIEN_","_"""NPISTATUS"""_","_"""C"""_","_XUSNPI_")"
+ I '$D(@XUSX) Q 0
+ S XUSX=XUSROOT_XUSIEN_","_"""NPISTATUS"""_","_"""C"""_","_XUSNPI_","_"""A"""_")"
+ S XUSRTN=$O(@XUSX,-1)
+ I '+XUSRTN Q 0
+ S XUSX=XUSROOT_XUSIEN_","_"""NPISTATUS"""_","_XUSRTN_","_0_")"
+ I '$D(@XUSX) Q 0
+ S XUSRTN=$G(@XUSX) I XUSRTN S XUSRTN=XUSIEN_"^"_$P(XUSRTN,"^")_"^"_$P(XUSRTN,"^",2)
+ I $P(XUSRTN,"^",3)=1 S $P(XUSRTN,"^",3)="Active"
+ I $P(XUSRTN,"^",3)=0 S $P(XUSRTN,"^",3)="Inactive"
+ Q XUSRTN
+ ;
+CHKDGT(XUSNPI) ;
+ ;  Function to validate the format of an NPI number.  It checks the
+ ;  length of the number, whether the NPI is numeric, and whether
+ ;  the check digit is valid.
+ ;
+ ;  Input parameter:
+ ;    NPI - 10-digit NPI number to validate.
+ ;
+ ;  Output parameter:
+ ;    Boolean value indicating whether the NPI has a valid format
+ ;
+ ;  NPI must be 10 digits long.
+ I XUSNPI'?10N Q 0
+ Q $E(XUSNPI,10)=$$CKDIGIT($E(XUSNPI,1,9))
+ ;
+CKDIGIT(XUSNPI) ;
+ ;  Function to calculate and return the check digit of an NPI.
+ ;  The check digit is calculated using the Luhn Formula for
+ ;  Modulus 10 "double-add-double" Check Digit.  A value of 24 is
+ ;  added to the total to account for the implied USA (80840) prefix.
+ ;
+ N XUSCTOT,XUSCN,XUSCDIG,XUSI
+ S XUSCTOT=24
+ F XUSI=9:-2:1 S XUSCN=2*$E(XUSNPI,XUSI),XUSCTOT=XUSCTOT+$E(XUSCN)+$E(XUSCN,2)+$E(XUSNPI,XUSI-1)
+ S XUSCDIG=150-XUSCTOT
+ Q $E(XUSCDIG,$L(XUSCDIG))
+ ;
+CHKDT(XUSQI,XUSIEN,XUSDATE) ; Check Date
+ ;;============================================================================
+ ;;  XUSQI   : Qualified Identifier. Required. For examble: "Individual_ID"
+ ;;  XUSIEN  : Internal Entry Number. Required.
+ ;;  XUSDATE : The Effective Date value to test. Must be FM date. Required. 
+ ;;  
+ ;;  If input passes date comparison, return 1.
+ ;;  Else return 0.
+ ;;============================================================================
+ ; 
+ I $G(XUSIEN)'>0 Q "0^Invalid IEN."
+ ;I (XUSIEN?.N)=0 Q "0^Invalid IEN."
+ I ((XUSIEN?.N)!(XUSIEN?.N1"."1N.N))=0 Q "-1^Invalid IEN"
+ N X,Y,%DT S %DT="T",X=$G(XUSDATE) D ^%DT I Y'=XUSDATE Q "0^Invalid Effective Date. Must be FM Date/Time."
+ ;-----------------------------------
+ N XUSROOT,XUSDA
+ N XUSCRDT S XUSCRDT=$$NOW^XLFDT I XUSDATE>XUSCRDT Q 0
+ ; get global from Parameter file base on Qualified Identifier.
+ S XUSROOT=$$GET^XPAR("PKG.KERNEL","XUSNPI QUALIFIED IDENTIFIER",XUSQI)
+ I $E(XUSROOT)'="^" S XUSROOT="^"_XUSROOT
+ I XUSROOT="^" Q "0^Invalid Qualified Identifier."
+ I $$GLCK(XUSROOT)'>0 Q "-1^Invalid Qualified Identifier"
+ N XUIENCK S XUIENCK=XUSROOT_XUSIEN_","_0_")" I $D(@XUIENCK)'>0 Q "0^Invalid IEN."
+ S XUSROOT=XUSROOT_XUSIEN_","_"""NPISTATUS"""_","_"""B"""_","_"""A"""_")",XUSDA=$O(@XUSROOT,-1)
+ Q (XUSDATE'<XUSDA)
Index: WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/XUSNPIDA.m
===================================================================
--- WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/XUSNPIDA.m	(revision 613)
+++ WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/XUSNPIDA.m	(revision 623)
@@ -1,345 +1,343 @@
-XUSNPIDA	;FO-OAKLAND/JLI - SPECIFIED TAXONOMY VALUES FOR NPI RECIPIENTS ;4/8/08  18:18
-	;;8.0;KERNEL;**420,410,480**;Jul 10, 1995;Build 38
-	;;Per VHA Directive 2004-038, this routine should not be modified
-	Q
-	;
-CHKGLOB()	;  returns global location of TAXONOMY values also rebuilds if they are missing
-	N I,STR,XUGLOB
-	S XUGLOB=$NA(^XTMP("NPIVALS"))
-	; check for ;;; is to permit sites to add a ; to exclude some values not used at site
-	I '$D(@XUGLOB) F I=1:1 S STR=$T(@("VALUES+"_I_"^XUSNPIDA")) I STR'[";;;" S STR=$P(STR,";;",2) Q:STR=""  S @XUGLOB@(STR)=""
-	S @XUGLOB@(0)=$$FMADD^XLFDT(DT,15)
-	Q XUGLOB
-	;
-VALUES	;
-	;;101Y00000X
-	;;101YA0400X
-	;;101YM0800X
-	;;101YP1600X
-	;;101YP2500X
-	;;101YS0200X
-	;;103G00000X
-	;;103GC0700X
-	;;103T00000X
-	;;103TA0400X
-	;;103TA0700X
-	;;103TB0200X
-	;;103TC0700X
-	;;103TC1900X
-	;;103TC2200X
-	;;103TE1000X
-	;;103TE1100X
-	;;103TF0000X
-	;;103TF0200X
-	;;103TH0100X
-	;;103TM1700X
-	;;103TM1800X
-	;;103TP0814X
-	;;103TP2700X
-	;;103TP2701X
-	;;103TR0400X
-	;;103TS0200X
-	;;103TW0100X
-	;;104100000X
-	;;1041C0700X
-	;;1041S0200X
-	;;111N00000X
-	;;111NI0900X
-	;;111NN0400X
-	;;111NN1001X
-	;;111NR0200X
-	;;111NS0005X
-	;;111NT0100X
-	;;111NX0100X
-	;;111NX0800X
-	;;122300000X
-	;;1223D0001X
-	;;1223E0200X
-	;;1223G0001X
-	;;1223P0106X
-	;;1223P0221X
-	;;1223P0300X
-	;;1223P0700X
-	;;1223S0112X
-	;;1223X0008X
-	;;1223X0400X
-	;;133V00000X
-	;;133VN1004X
-	;;133VN1005X
-	;;133VN1006X
-	;;152W00000X
-	;;152WC0802X
-	;;152WL0500X
-	;;152WP0200X
-	;;152WS0006X
-	;;152WV0400X
-	;;152WX0102X
-	;;170100000X
-	;;183500000X
-	;;1835G0000X
-	;;1835N0905X
-	;;1835N1003X
-	;;1835P1200X
-	;;1835P1300X
-	;;204C00000X
-	;;204D00000X
-	;;204E00000X
-	;;204F00000X
-	;;207K00000X
-	;;207KA0200X
-	;;207KI0005X
-	;;207L00000X
-	;;207LA0401X
-	;;207LC0200X
-	;;207LP2900X
-	;;207N00000X
-	;;207ND0101X
-	;;207ND0900X
-	;;207NI0002X
-	;;207NP0225X
-	;;207NS0135X
-	;;207P00000X
-	;;207PE0004X
-	;;207PE0005X
-	;;207PP0204X
-	;;207PS0010X
-	;;207PT0002X
-	;;207Q00000X
-	;;207QA0000X
-	;;207QA0401X
-	;;207QA0505X
-	;;207QG0300X
-	;;207QS0010X
-	;;207R00000X
-	;;207RA0000X
-	;;207RA0201X
-	;;207RA0401X
-	;;207RC0000X
-	;;207RC0001X
-	;;207RC0200X
-	;;207RE0101X
-	;;207RG0100X
-	;;207RG0300X
-	;;207RH0000X
-	;;207RH0003X
-	;;207RI0001X
-	;;207RI0008X
-	;;207RI0011X
-	;;207RI0200X
-	;;207RM1200X
-	;;207RN0300X
-	;;207RP1001X
-	;;207RR0500X
-	;;207RS0010X
-	;;207RX0202X
-	;;207SC0300X
-	;;207SG0201X
-	;;207SG0202X
-	;;207SG0203X
-	;;207SG0205X
-	;;207SM0001X
-	;;207T00000X
-	;;207U00000X
-	;;207UN0901X
-	;;207UN0902X
-	;;207UN0903X
-	;;207V00000X
-	;;207VC0200X
-	;;207VE0102X
-	;;207VG0400X
-	;;207VM0101X
-	;;207VX0000X
-	;;207VX0201X
-	;;207W00000X
-	;;207X00000X
-	;;207XS0106X
-	;;207XS0114X
-	;;207XS0117X
-	;;207XX0004X
-	;;207XX0005X
-	;;207XX0801X
-	;;207Y00000X
-	;;207YP0228X
-	;;207YS0123X
-	;;207YX0007X
-	;;207YX0602X
-	;;207YX0901X
-	;;207YX0905X
-	;;207ZB0001X
-	;;207ZC0500X
-	;;207ZD0900X
-	;;207ZF0201X
-	;;207ZH0000X
-	;;207ZI0100X
-	;;207ZM0300X
-	;;207ZN0500X
-	;;207ZP0007X
-	;;207ZP0101X
-	;;207ZP0102X
-	;;207ZP0104X
-	;;207ZP0105X
-	;;207ZP0213X
-	;;208000000X
-	;;2080A0000X
-	;;2080I0007X
-	;;2080N0001X
-	;;2080P0006X
-	;;2080P0008X
-	;;2080P0201X
-	;;2080P0202X
-	;;2080P0203X
-	;;2080P0204X
-	;;2080P0205X
-	;;2080P0206X
-	;;2080P0207X
-	;;2080P0208X
-	;;2080P0210X
-	;;2080P0214X
-	;;2080P0216X
-	;;2080S0010X
-	;;2080T0002X
-	;;208100000X
-	;;2081P0004X
-	;;2081P0010X
-	;;2081P2900X
-	;;2081S0010X
-	;;208200000X
-	;;2082S0099X
-	;;2082S0105X
-	;;2083A0100X
-	;;2083P0011X
-	;;2083P0500X
-	;;2083P0901X
-	;;2083S0010X
-	;;2083T0002X
-	;;2083X0100X
-	;;2084A0401X
-	;;2084F0202X
-	;;2084N0400X
-	;;2084N0402X
-	;;2084N0600X
-	;;2084P0005X
-	;;2084P0800X
-	;;2084P0802X
-	;;2084P0804X
-	;;2084P0805X
-	;;2084P2900X
-	;;2084S0010X
-	;;2084V0102X
-	;;2085B0100X
-	;;2085N0700X
-	;;2085N0904X
-	;;2085P0229X
-	;;2085R0001X
-	;;2085R0202X
-	;;2085R0203X
-	;;2085R0204X
-	;;2085R0205X
-	;;2085U0001X
-	;;208600000X
-	;;2086S0102X
-	;;2086S0105X
-	;;2086S0120X
-	;;2086S0122X
-	;;2086S0127X
-	;;2086S0129X
-	;;2086X0206X
-	;;208800000X
-	;;208C00000X
-	;;208D00000X
-	;;208G00000X
-	;;208M00000X
-	;;208U00000X
-	;;208VP0000X
-	;;208VP0014X
-	;;209800000X
-	;;213E00000X
-	;;213EG0000X
-	;;213EP0504X
-	;;213EP1101X
-	;;213ER0200X
-	;;213ES0000X
-	;;213ES0103X
-	;;213ES0131X
-	;;225100000X
-	;;2251C2600X
-	;;2251E1200X
-	;;2251E1300X
-	;;2251G0304X
-	;;2251H1200X
-	;;2251H1300X
-	;;2251N0400X
-	;;2251P0200X
-	;;2251S0007X
-	;;2251X0800X
-	;;225X00000X
-	;;225XE1200X
-	;;225XH1200X
-	;;225XH1300X
-	;;225XN1300X
-	;;225XP0200X
-	;;225XR0403X
-	;;231H00000X
-	;;231HA2400X
-	;;231HA2500X
-	;;237600000X
-	;;363A00000X
-	;;363AM0700X
-	;;363AS0400X
-	;;363L00000X
-	;;363LA2100X
-	;;363LA2200X
-	;;363LC0200X
-	;;363LC1500X
-	;;363LF0000X
-	;;363LG0600X
-	;;363LN0000X
-	;;363LN0005X
-	;;363LP0200X
-	;;363LP0222X
-	;;363LP0808X
-	;;363LP1700X
-	;;363LP2300X
-	;;363LS0200X
-	;;363LW0102X
-	;;363LX0001X
-	;;363LX0106X
-	;;364S00000X
-	;;364SA2100X
-	;;364SA2200X
-	;;364SC0200X
-	;;364SC1501X
-	;;364SC2300X
-	;;364SE0003X
-	;;364SE1400X
-	;;364SF0001X
-	;;364SG0600X
-	;;364SH0200X
-	;;364SH1100X
-	;;364SI0800X
-	;;364SL0600X
-	;;364SM0705X
-	;;364SN0000X
-	;;364SN0800X
-	;;364SP0200X
-	;;364SP0807X
-	;;364SP0808X
-	;;364SP0809X
-	;;364SP0810X
-	;;364SP0811X
-	;;364SP0812X
-	;;364SP0813X
-	;;364SP1700X
-	;;364SP2800X
-	;;364SR0400X
-	;;364SS0200X
-	;;364ST0500X
-	;;364SW0102X
-	;;364SX0106X
-	;;364SX0200X
-	;;364SX0204X
-	;;367500000X
-	;;367A00000X
-	;;367H00000X
-	;;390200000X
-	;;
+XUSNPIDA ;FO-OAKLAND/JLI - SPECIFIED TAXONOMY VALUES FOR NPI RECIPIENTS ;8/22/06  11:37
+ ;;8.0;KERNEL;**420,410**;Jul 10, 1995;Build 27
+ Q
+ ;
+CHKGLOB() ;  returns global location of TAXONOMY values also rebuilds if they are missing
+ N I,STR,XUGLOB
+ S XUGLOB=$NA(^XTMP("NPIVALS"))
+ ; check for ;;; is to permit sites to add a ; to exclude some values not used at site
+ I '$D(@XUGLOB) F I=1:1 S STR=$T(@("VALUES+"_I_"^XUSNPIDA")) I STR'[";;;" S STR=$P(STR,";;",2) Q:STR=""  S @XUGLOB@(STR)=""
+ S @XUGLOB@(0)=$$FMADD^XLFDT(DT,15)
+ Q XUGLOB
+ ;
+VALUES ;
+ ;;101Y00000X
+ ;;101YA0400X
+ ;;101YM0800X
+ ;;101YP1600X
+ ;;101YP2500X
+ ;;101YS0200X
+ ;;103G00000X
+ ;;103GC0700X
+ ;;103T00000X
+ ;;103TA0400X
+ ;;103TA0700X
+ ;;103TB0200X
+ ;;103TC0700X
+ ;;103TC1900X
+ ;;103TC2200X
+ ;;103TE1000X
+ ;;103TE1100X
+ ;;103TF0000X
+ ;;103TF0200X
+ ;;103TH0100X
+ ;;103TM1700X
+ ;;103TM1800X
+ ;;103TP0814X
+ ;;103TP2700X
+ ;;103TP2701X
+ ;;103TR0400X
+ ;;103TS0200X
+ ;;103TW0100X
+ ;;104100000X
+ ;;1041C0700X
+ ;;1041S0200X
+ ;;111N00000X
+ ;;111NI0900X
+ ;;111NN0400X
+ ;;111NN1001X
+ ;;111NR0200X
+ ;;111NS0005X
+ ;;111NT0100X
+ ;;111NX0100X
+ ;;111NX0800X
+ ;;122300000X
+ ;;1223D0001X
+ ;;1223E0200X
+ ;;1223G0001X
+ ;;1223P0106X
+ ;;1223P0221X
+ ;;1223P0300X
+ ;;1223P0700X
+ ;;1223S0112X
+ ;;1223X0008X
+ ;;1223X0400X
+ ;;133V00000X
+ ;;133VN1004X
+ ;;133VN1005X
+ ;;133VN1006X
+ ;;152W00000X
+ ;;152WC0802X
+ ;;152WL0500X
+ ;;152WP0200X
+ ;;152WS0006X
+ ;;152WV0400X
+ ;;152WX0102X
+ ;;170100000X
+ ;;183500000X
+ ;;1835G0000X
+ ;;1835N0905X
+ ;;1835N1003X
+ ;;1835P1200X
+ ;;1835P1300X
+ ;;204C00000X
+ ;;204D00000X
+ ;;204E00000X
+ ;;204F00000X
+ ;;207K00000X
+ ;;207KA0200X
+ ;;207KI0005X
+ ;;207L00000X
+ ;;207LA0401X
+ ;;207LC0200X
+ ;;207LP2900X
+ ;;207N00000X
+ ;;207ND0101X
+ ;;207ND0900X
+ ;;207NI0002X
+ ;;207NP0225X
+ ;;207NS0135X
+ ;;207P00000X
+ ;;207PE0004X
+ ;;207PE0005X
+ ;;207PP0204X
+ ;;207PS0010X
+ ;;207PT0002X
+ ;;207Q00000X
+ ;;207QA0000X
+ ;;207QA0401X
+ ;;207QA0505X
+ ;;207QG0300X
+ ;;207QS0010X
+ ;;207R00000X
+ ;;207RA0000X
+ ;;207RA0201X
+ ;;207RA0401X
+ ;;207RC0000X
+ ;;207RC0001X
+ ;;207RC0200X
+ ;;207RE0101X
+ ;;207RG0100X
+ ;;207RG0300X
+ ;;207RH0000X
+ ;;207RH0003X
+ ;;207RI0001X
+ ;;207RI0008X
+ ;;207RI0011X
+ ;;207RI0200X
+ ;;207RM1200X
+ ;;207RN0300X
+ ;;207RP1001X
+ ;;207RR0500X
+ ;;207RS0010X
+ ;;207RX0202X
+ ;;207SC0300X
+ ;;207SG0201X
+ ;;207SG0202X
+ ;;207SG0203X
+ ;;207SG0205X
+ ;;207SM0001X
+ ;;207T00000X
+ ;;207U00000X
+ ;;207UN0901X
+ ;;207UN0902X
+ ;;207UN0903X
+ ;;207V00000X
+ ;;207VC0200X
+ ;;207VE0102X
+ ;;207VG0400X
+ ;;207VM0101X
+ ;;207VX0000X
+ ;;207VX0201X
+ ;;207W00000X
+ ;;207X00000X
+ ;;207XS0106X
+ ;;207XS0114X
+ ;;207XS0117X
+ ;;207XX0004X
+ ;;207XX0005X
+ ;;207XX0801X
+ ;;207Y00000X
+ ;;207YP0228X
+ ;;207YS0123X
+ ;;207YX0007X
+ ;;207YX0602X
+ ;;207YX0901X
+ ;;207YX0905X
+ ;;207ZB0001X
+ ;;207ZC0500X
+ ;;207ZD0900X
+ ;;207ZF0201X
+ ;;207ZH0000X
+ ;;207ZI0100X
+ ;;207ZM0300X
+ ;;207ZN0500X
+ ;;207ZP0007X
+ ;;207ZP0101X
+ ;;207ZP0102X
+ ;;207ZP0104X
+ ;;207ZP0105X
+ ;;207ZP0213X
+ ;;208000000X
+ ;;2080A0000X
+ ;;2080I0007X
+ ;;2080N0001X
+ ;;2080P0006X
+ ;;2080P0008X
+ ;;2080P0201X
+ ;;2080P0202X
+ ;;2080P0203X
+ ;;2080P0204X
+ ;;2080P0205X
+ ;;2080P0206X
+ ;;2080P0207X
+ ;;2080P0208X
+ ;;2080P0210X
+ ;;2080P0214X
+ ;;2080P0216X
+ ;;2080S0010X
+ ;;2080T0002X
+ ;;208100000X
+ ;;2081P0004X
+ ;;2081P0010X
+ ;;2081P2900X
+ ;;2081S0010X
+ ;;208200000X
+ ;;2082S0099X
+ ;;2082S0105X
+ ;;2083A0100X
+ ;;2083P0011X
+ ;;2083P0500X
+ ;;2083P0901X
+ ;;2083S0010X
+ ;;2083T0002X
+ ;;2083X0100X
+ ;;2084A0401X
+ ;;2084F0202X
+ ;;2084N0400X
+ ;;2084N0402X
+ ;;2084N0600X
+ ;;2084P0005X
+ ;;2084P0800X
+ ;;2084P0802X
+ ;;2084P0804X
+ ;;2084P0805X
+ ;;2084P2900X
+ ;;2084S0010X
+ ;;2084V0102X
+ ;;2085B0100X
+ ;;2085N0700X
+ ;;2085N0904X
+ ;;2085P0229X
+ ;;2085R0001X
+ ;;2085R0202X
+ ;;2085R0203X
+ ;;2085R0204X
+ ;;2085R0205X
+ ;;2085U0001X
+ ;;208600000X
+ ;;2086S0102X
+ ;;2086S0105X
+ ;;2086S0120X
+ ;;2086S0122X
+ ;;2086S0127X
+ ;;2086S0129X
+ ;;2086X0206X
+ ;;208800000X
+ ;;208C00000X
+ ;;208D00000X
+ ;;208G00000X
+ ;;208M00000X
+ ;;208U00000X
+ ;;208VP0000X
+ ;;208VP0014X
+ ;;209800000X
+ ;;213E00000X
+ ;;213EG0000X
+ ;;213EP0504X
+ ;;213EP1101X
+ ;;213ER0200X
+ ;;213ES0000X
+ ;;213ES0103X
+ ;;213ES0131X
+ ;;225100000X
+ ;;2251C2600X
+ ;;2251E1200X
+ ;;2251E1300X
+ ;;2251G0304X
+ ;;2251H1200X
+ ;;2251H1300X
+ ;;2251N0400X
+ ;;2251P0200X
+ ;;2251S0007X
+ ;;2251X0800X
+ ;;225X00000X
+ ;;225XE1200X
+ ;;225XH1200X
+ ;;225XH1300X
+ ;;225XN1300X
+ ;;225XP0200X
+ ;;225XR0403X
+ ;;231H00000X
+ ;;231HA2400X
+ ;;231HA2500X
+ ;;237600000X
+ ;;363A00000X
+ ;;363AM0700X
+ ;;363AS0400X
+ ;;363L00000X
+ ;;363LA2100X
+ ;;363LA2200X
+ ;;363LC0200X
+ ;;363LC1500X
+ ;;363LF0000X
+ ;;363LG0600X
+ ;;363LN0000X
+ ;;363LN0005X
+ ;;363LP0200X
+ ;;363LP0222X
+ ;;363LP0808X
+ ;;363LP1700X
+ ;;363LP2300X
+ ;;363LS0200X
+ ;;363LW0102X
+ ;;363LX0001X
+ ;;363LX0106X
+ ;;364S00000X
+ ;;364SA2100X
+ ;;364SA2200X
+ ;;364SC0200X
+ ;;364SC1501X
+ ;;364SC2300X
+ ;;364SE0003X
+ ;;364SE1400X
+ ;;364SF0001X
+ ;;364SG0600X
+ ;;364SH0200X
+ ;;364SH1100X
+ ;;364SI0800X
+ ;;364SL0600X
+ ;;364SM0705X
+ ;;364SN0000X
+ ;;364SN0800X
+ ;;364SP0200X
+ ;;364SP0807X
+ ;;364SP0808X
+ ;;364SP0809X
+ ;;364SP0810X
+ ;;364SP0811X
+ ;;364SP0812X
+ ;;364SP0813X
+ ;;364SP1700X
+ ;;364SP2800X
+ ;;364SR0400X
+ ;;364SS0200X
+ ;;364ST0500X
+ ;;364SW0102X
+ ;;364SX0106X
+ ;;364SX0200X
+ ;;364SX0204X
+ ;;367500000X
+ ;;367A00000X
+ ;;367H00000X
+ ;;
